org.apache.hadoop.service

## Interface ServiceStateChangeListener

- All Known Implementing Classes:
    LoggingStateChangeListener

      @InterfaceAudience.Public
       @InterfaceStability.Stable
      public interface ServiceStateChangeListener

  Interface to notify state changes of a service.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `stateChanged(Service service)` Callback to notify of a state change.

- - ### Method Detail

    - #### stateChanged

          void stateChanged(Service service)

      Callback to notify of a state change. The service will already have changed state before this callback is invoked. This operation is invoked on the thread that initiated the state change, while the service itself in in a sychronized section.
      1. Any long-lived operation here will prevent the service state change from completing in a timely manner.
      2. If another thread is somehow invoked from the listener, and that thread invokes the methods of the service (including subclass-specific methods), there is a risk of a deadlock.
      Parameters:
        `service` - the service that has changed.

Copyright © 2022 Apache Software Foundation. All rights reserved.